Package: fastdid
Type: Package
Title: Fast Staggered Difference-in-Difference Estimators
Version: 1.0.6
Date: 2025-12-25
Authors@R: c(
  person("Lin-Tung","Tsai",
         role = c("aut", "cre", "cph"),
         email = "tsaidondon@gmail.com"),
  person(given = "Maxwell",
         family = "Kellogg",
         role = "ctb"),
  person(given = "Kuan-Ju",
         family = "Tseng",
          role = "ctb"))
Maintainer: Lin-Tung Tsai <tsaidondon@gmail.com>
Description: A fast and flexible implementation of Callaway and Sant'Anna's (2021)<doi:10.1016/j.jeconom.2020.12.001> staggered Difference-in-Differences (DiD) estimators, 'fastdid' reduces the computation time from hours to seconds, and incorporates extensions such as time-varying covariates and multiple events. 
License: MIT + file LICENSE
Depends: R (>= 4.1.0)
Imports: data.table (>= 1.15.0), stringr, BMisc, collapse, dreamerr (>=
        1.4.0), ggplot2
Suggests: did, knitr, parallel, rmarkdown, tinytest
Encoding: UTF-8
RoxygenNote: 7.3.2
URL: https://github.com/TsaiLintung/fastdid,
        https://tsailintung.github.io/fastdid/
BugReports: https://github.com/TsaiLintung/fastdid/issues
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2026-01-15 00:08:39 UTC; lttsai
Author: Lin-Tung Tsai [aut, cre, cph],
  Maxwell Kellogg [ctb],
  Kuan-Ju Tseng [ctb]
Repository: CRAN
Date/Publication: 2026-01-15 00:30:02 UTC
Built: R 4.6.0; ; 2026-04-25 13:41:26 UTC; unix

Package: fastdid
Type: Package
Title: Fast Staggered Difference-in-Difference Estimators
Version: 1.0.6
Date: 2025-12-25
Authors@R: c(
  person("Lin-Tung","Tsai",
         role = c("aut", "cre", "cph"),
         email = "tsaidondon@gmail.com"),
  person(given = "Maxwell",
         family = "Kellogg",
         role = "ctb"),
  person(given = "Kuan-Ju",
         family = "Tseng",
          role = "ctb"))
Maintainer: Lin-Tung Tsai <tsaidondon@gmail.com>
Description: A fast and flexible implementation of Callaway and Sant'Anna's (2021)<doi:10.1016/j.jeconom.2020.12.001> staggered Difference-in-Differences (DiD) estimators, 'fastdid' reduces the computation time from hours to seconds, and incorporates extensions such as time-varying covariates and multiple events. 
License: MIT + file LICENSE
Depends: R (>= 4.1.0)
Imports: data.table (>= 1.15.0), stringr, BMisc, collapse, dreamerr (>=
        1.4.0), ggplot2
Suggests: did, knitr, parallel, rmarkdown, tinytest
Encoding: UTF-8
RoxygenNote: 7.3.2
URL: https://github.com/TsaiLintung/fastdid,
        https://tsailintung.github.io/fastdid/
BugReports: https://github.com/TsaiLintung/fastdid/issues
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2026-01-15 00:08:39 UTC; lttsai
Author: Lin-Tung Tsai [aut, cre, cph],
  Maxwell Kellogg [ctb],
  Kuan-Ju Tseng [ctb]
Repository: CRAN
Date/Publication: 2026-01-15 00:30:02 UTC
Built: R 4.6.0; ; 2026-04-26 02:06:38 UTC; unix

# fastdid

  <!-- badges: start -->
  [![R-CMD-check](https://github.com/TsaiLintung/fastdid/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/TsaiLintung/fastdid/actions/workflows/R-CMD-check.yaml)
  [![](https://www.r-pkg.org/badges/version/fastdid?color=blue)](https://cran.r-project.org/package=fastdid)
  [![CRANd](https://cranlogs.r-pkg.org/badges/grand-total/fastdid?color=blue)](https://CRAN.R-project.org/package=fastdid)
  <!-- badges: end -->

fastdid implements the Difference-in-Differences (DiD) estimators in [Callaway and Sant'Anna's (2021)](https://doi.org/10.1016/j.jeconom.2020.12.001). fastdid is

  - fast, reducing the computation time with millions of units from hours to [seconds](https://tsailintung.github.io/fastdid/articles/misc.html#performance),
  - flexible, allowing extensions such as time-varying covariates [Caetano and Callaway, 2024](https://arxiv.org/abs/2406.15288) and multiple events ([Tsai 2024](https://arxiv.org/abs/2409.05184)). 

# Getting Started

fastdid can be installed from CRAN,

```
install.packages("fastdid")
```

or the latest developmental version can be installed via GitHub,

```
# install.packages("devtools")
devtools::install_github("TsaiLintung/fastdid")
```

To use `fastdid`, you need to provide the dataset `data`, the column name of time `timevar`, cohort `cohortvar`, unit `unitvar`, and outcome(s) `outcomevar`. Here is a simple call:

```
library(fastdid) #loading the package
did_sim <- sim_did(1e+03, 10) #simulate some data
did_estimate <- fastdid(data = did_sim$dt, timevar = "time",
                  cohortvar = "G", unitvar = "unit", outcomevar = "y")
```
The function returns a `data.table` that includes the estimates. Column `att` is the point estimate, `se` the standard error of the estimate, `att_ciub` and `att_cilb` the confidence interval. The other columns indexes the estimated parameter. 

To create event study plots, use `plot_did_dynamics(did_estimate)`. 

# More

  - [did](https://bcallaway11.github.io/did/articles/did-basics.html): staggered Difference in Difference by Callaway and Sant'Anna
  - [fastdid](https://tsailintung.github.io/fastdid/reference/fastdid.html): full list of arguments and features.
  - [double](https://tsailintung.github.io/fastdid/articles/double.html): introduction to DiD with multiple events.
  - [misc](https://tsailintung.github.io/fastdid/articles/misc.html): comparison with [did](https://github.com/bcallaway11/did), benchmark, tests, and experimental features.

# Acknowledgments

**fastdid** is created and maintained by Lin-Tung Tsai. Many thanks to Maxwell Kellogg and Kuan-Ju Tseng for their contribution. 

# setup --------------------------------------------------------

tol <- 1e-2 #allow 1% different between estimates
simdt <- sim_did(1e+02, 10, cov = "cont", hetero = "all", balanced = TRUE, second_outcome = TRUE, seed = 1, 
                 stratify = FALSE, second_cov = TRUE, vary_cov = TRUE)
dt <- simdt$dt

# did plot ---------------

fd <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit", outcomevar = "y", result_type = "dynamic")
expect_inherits(plot_did_dynamics(fd), "ggplot", info = "plot dynamics")

fd <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit", outcomevar = "y", result_type = "group")
expect_inherits(plot_did_dynamics(fd, margin = "group"), "ggplot", info = "plot group")

fd <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit", outcomevar = "y", result_type = "time")
expect_inherits(plot_did_dynamics(fd, margin = "time"), "ggplot", info = "plot time")

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
library(fastdid)
library(ggplot2)
library(data.table)
simdt <- sim_did(1e+04, 5, cov = "cont", hetero = "all", balanced = TRUE, seed = 1, 
                 second_cohort = TRUE, second_het = "no") #comfounding event
dt <- simdt$dt #dataset

#ground truth att
att <- simdt$att |> merge(dt[,.(w = .N),by = "G"], by = "G")
att[, event_time := time-G]
att <- att[event == 1,.(att = weighted.mean(attgt, w)), by = "event_time"]

## ----naive--------------------------------------------------------------------
naive_result <-fastdid(data = dt, 
                 timevar = "time", cohortvar = "G", unitvar = "unit", 
                 outcomevar = "y", result_type = "dynamic")
plot_did_dynamics(naive_result) + 
  geom_line(aes(y = att, x = event_time), 
            data = att, color = "red") + theme_bw()

## ----diag---------------------------------------------------------------------
dt[, D2 := time >= G2]
diag <- fastdid(data = dt, 
                 timevar = "time", cohortvar = "G", unitvar = "unit",
                 outcomevar = "D2", result_type = "dynamic")
plot_did_dynamics(diag) + theme_bw()

## ----double-------------------------------------------------------------------
double_result <-fastdid(data = dt, 
                 timevar = "time", cohortvar = "G", unitvar = "unit",
                 outcomevar = "y", result_type = "dynamic",
                 cohortvar2 = "G2", event_specific = TRUE)
plot_did_dynamics(double_result) + 
  geom_line(aes(y = att, x = event_time), 
            data = att, color = "red") + theme_bw()

## ----agg----------------------------------------------------------------------
double_result_ds <-fastdid(data = dt, 
                 timevar = "time", cohortvar = "G", unitvar = "unit",
                 outcomevar = "y", result_type = "dynamic_stagger",
                 cohortvar2 = "G2", event_specific = TRUE)

double_result_ggt <-fastdid(data = dt, 
                 timevar = "time", cohortvar = "G", unitvar = "unit",
                 outcomevar = "y", result_type = "group_group_time",
                 cohortvar2 = "G2", event_specific = TRUE)

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----table1, echo=FALSE, message=FALSE, warnings=FALSE, results='asis'--------
tabl <- "
| fastdid | did | control group used |
|-|-|-|
| both | notyettreated | never-treated + not-yet-but-eventually-treated |
| never| nevertreated  | never-treated |
| notyet | | not-yet-but-eventually-treated |
"
cat(tabl) # output the table in a format good for HTML/PDF/docx conversion

## ----table2, echo=FALSE, message=FALSE, warnings=FALSE, results='asis'--------
tabl <- "
| fastdid | did |
|-|-|
| group_time | no aggregation |
|dynamic|dynamic|
|time|calendar|
|group|group|
|simple|simple|
"
cat(tabl) # output the table in a format good for HTML/PDF/docx conversion

# setup --------------------------------------------------------

simdt <- sim_did(100, 5, cov = "cont", hetero = "all", balanced = TRUE, seed = 1)
dt <- simdt$dt

# drop all controls in time 3 to trigger insufficient control observations
no_control <- dt[!(time == 3 & G >= 3)]
expect_warning(
  fastdid(no_control, timevar = "time", cohortvar = "G", unitvar = "unit",
          outcomevar = "y", result_type = "group_time", allow_unbalance_panel = TRUE),
  info = "rc did insufficient control"
)

tol <- 1e-2 #allow 1% different between estimates
simdt <- sim_did(1e+03, 5, cov = "cont", hetero = "all", balanced = TRUE, second_outcome = FALSE, seed = 1, 
                 stratify = FALSE, second_cov = TRUE, vary_cov = TRUE, second_cohort = TRUE)
dt <- simdt$dt

# basic tests ------------------------------------------------------------------

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      cohortvar2 = "G2"),
              info = "double call")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      cohortvar2 = "G2", event_specific = FALSE),
              info = "double, combined effect")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      cohortvar2 = "G2", allow_unbalance_panel = TRUE),
              info = "double, unbalanced panel")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      cohortvar2 = "G2", control_option = "never"),
              info = "double, only never")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      cohortvar2 = "G2", double_control_option = "never"),
              info = "double call, double never")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      cohortvar2 = "G2", double_control_option = "notyet"),
              info = "double cal, double notyet")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      covariatesvar = "x",
                      cohortvar2 = "G2"),
              info = "double, covariates")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_group_time",
                      cohortvar2 = "G2"),
              info = "double, ggt")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "dynamic_stagger",
                      cohortvar2 = "G2"),
              info = "double, dynamic_sq")

# non-standard data ---------------------------------------------------------

dt2 <- data.table::copy(dt)
dt2 <- dt2[G < 4]
expect_silent(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      cohortvar2 = "G2", allow_unbalance_panel = TRUE, control_option = "notyet"),
              info = "double, limited treated group")


#all G2 > G
dt2 <- data.table::copy(dt)
dt2 <- dt2[G < G2]
expect_silent(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      cohortvar2 = "G2", allow_unbalance_panel = TRUE, control_option = "notyet"),
              info = "double, G2 > G")

#all G > G2
dt2 <- data.table::copy(dt)
dt2 <- dt2[G2 < G]
expect_silent(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      cohortvar2 = "G2", allow_unbalance_panel = TRUE, control_option = "notyet"),
              info = "double, G > G2")


dt2 <- data.table::copy(dt)
keep <- sample(c(rep(TRUE, 15),FALSE), dt2[,.N], TRUE)
dt2 <- dt2[keep]
expect_silent(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      cohortvar2 = "G2", allow_unbalance_panel = TRUE),
              info = "double, unbalanced panel, unbalanced data")

dt2 <- data.table::copy(dt)
dt2[, time := time*2 + 3]
dt2[, G := G*2 + 3]
dt2[, G2 := G2*2 + 3]

expect_silent(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      cohortvar2 = "G2"),
             info = "time offset")

if(.Platform$OS.type == "unix" & at_home() & requireNamespace("parallel")){
  expect_silent(fastdid(dt, timevar = "time",cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                        cohortvar2 = "G2", parallel = TRUE),
                info = "parallel double")
}

# setup ----------------------

library(did)
#set.seed(1)
tol <- 1e-2 #allow 1% different between estimates
simdt <- sim_did(1e+03, 10, cov = "cont", hetero = "all", balanced = TRUE, second_outcome = TRUE,
                 seed = 1, stratify = FALSE,
                 second_cov = TRUE)
dt <- simdt$dt

est_diff_ratio <- function(result, did_result){
  did_result_dt <- data.table::data.table(cohort = did_result$group, time = did_result$t, did_att = did_result$att, did_se = did_result$se)
  did_result_dt <- did_result_dt[did_att != 0]
  compare <- did_result_dt |> merge(result, by = c("cohort", "time"), all = TRUE) 
  att_diff_per <- compare[, sum(abs(did_att-att), na.rm = TRUE)/sum(did_att, na.rm = TRUE)]
  se_diff_per <- compare[, sum(abs(did_se-se), na.rm = TRUE)/sum(did_se, na.rm = TRUE)]
  return(c(att_diff_per , se_diff_per))
}

est_diff_ratio_agg <- function(result, did_result){
  names(result) <- c("target", "att", "se", "outcome", "atub", "atlb")
  did_result_dt <- data.table::data.table(target = did_result$egt, did_att = did_result$att.egt, did_se = did_result$se.egt)
  compare <- did_result_dt |> merge(result, by = c("target"), all = TRUE) 
  att_diff_per <- compare[, sum(abs(did_att-att), na.rm = TRUE)/sum(did_att, na.rm = TRUE)]
  se_diff_per <- compare[, sum(abs(did_se-se), na.rm = TRUE)/sum(did_se, na.rm = TRUE)]
  return(c(att_diff_per , se_diff_per))
}

# simple -------------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time")
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "ipw",cband = FALSE,
                          #xformla = ~x,
                          control_group = "notyettreated",
                          clustervars = NULL,
                          bstrap = FALSE)

expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "simple")
rm(result, did_result)

# simple notyet only ----------------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time", control_option = "notyet")
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt[!is.infinite(G)],base_period = "universal",est_method = "ipw",cband = FALSE,
                          #xformla = ~x,
                          control_group = "notyettreated",
                          clustervars = NULL,
                          bstrap = FALSE)

expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "notyet")
rm(result, did_result)

# never -------------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                  control_option = "never")
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "ipw",cband = FALSE,
                          #xformla = ~x,
                          control_group = "nevertreated",
                          clustervars = NULL,
                          bstrap = FALSE)

expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "never treated")
rm(result, did_result)

# covariates -------------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                  control_type = "ipw",
                  covariatesvar = c("x", "x2"))
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "ipw",cband = FALSE,
                          xformla = ~x+x2,
                          control_group = "notyettreated",
                          clustervars = NULL,
                          bstrap = FALSE)

expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "covariates ipw")
rm(result, did_result)

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                  control_type = "reg",
                  covariatesvar = c("x", "x2"))
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "reg",cband = FALSE,
                          xformla = ~x+x2,
                          control_group = "notyettreated",
                          clustervars = NULL,
                          bstrap = FALSE)

expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "covariates reg")
rm(result, did_result)


result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                  control_type = "dr",
                  covariatesvar = c("x"))
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "dr",cband = FALSE,
                          xformla = ~x,
                          control_group = "notyettreated",
                          clustervars = NULL,
                          bstrap = FALSE)

expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "covariates dr")
rm(result, did_result)

# anticipation -----------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                  control_type = "dr",
                  covariatesvar = c("x"), anticipation = 2)
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "dr",cband = FALSE,
                          xformla = ~x,
                          control_group = "notyettreated",
                          clustervars = NULL,
                          bstrap = FALSE, anticipation = 2)

expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "anticipation")
rm(result, did_result)

# alternative base period -----------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                  control_type = "dr",
                  covariatesvar = c("x"), base_period = "varying")
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "varying",est_method = "dr",cband = FALSE,
                          xformla = ~x,
                          control_group = "notyettreated",
                          clustervars = NULL,
                          bstrap = FALSE)

expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "varying base period")
rm(result, did_result)

# bootstrap --------------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                  boot = TRUE, biters = 10000)
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "ipw",cband = FALSE,
                          control_group = "notyettreated",
                          clustervars = NULL,
                          bstrap = TRUE, biters = 10000)

expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "bootstrap")
rm(result, did_result)

# bootstrap clustered --------------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                  clustervar = "x",
                  boot = TRUE, biters = 10000)
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "ipw",cband = FALSE,
                          control_group = "notyettreated",
                          clustervars = "x",
                          bstrap = TRUE, biters = 10000)

expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "bootstrap clustered")
rm(result, did_result)

#multiple outcome ------------------------------------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = c("y", "y2"),  result_type = "group_time")
did_result <- did::att_gt(yname = "y2",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "ipw",cband = FALSE,
                          #xformla = ~x,
                          control_group = "notyettreated",
                          clustervars = NULL,
                          bstrap = FALSE)

expect_equal(est_diff_ratio(result[outcome == "y2"], did_result), c(0,0), tolerance = tol,
             info = "simple multiple outcome")
rm(result, did_result)


result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = c("y", "y2"),  result_type = "group_time",
                  covariatesvar = "x")
did_result <- did::att_gt(yname = "y2",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "ipw",cband = FALSE,
                          xformla = ~x,
                          control_group = "notyettreated",
                          clustervars = NULL,
                          bstrap = FALSE)

expect_equal(est_diff_ratio(result[outcome == "y2"], did_result), c(0,0), tolerance = tol,
             info = "multiple outcome with covariates")
rm(result, did_result)



# dynamic -------------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "dynamic")
did_result_gt <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "ipw",cband = FALSE,
                             #xformla = ~x,
                             control_group = "notyettreated",
                             clustervars = NULL,
                             bstrap = FALSE)
did_result <- did::aggte(did_result_gt, type = "dynamic")
expect_equal(est_diff_ratio_agg(result, did_result), c(0,0), tolerance = tol,
             info = "dynamic")
rm(result, did_result)

# group -------------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group")
result <- result[type == "post",]
result[, type := NULL]
did_result_gt <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "ipw",cband = FALSE,
                             #xformla = ~x,
                             control_group = "notyettreated",
                             clustervars = NULL,
                             bstrap = FALSE)
did_result <- did::aggte(did_result_gt, type = "group")
expect_equal(est_diff_ratio_agg(result, did_result), c(0,0), tolerance = tol,
             info = "group")
rm(result, did_result)

# time --------------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "time")
result <- result[type == "post",]
result[, type := NULL]
did_result_gt <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "ipw",cband = FALSE,
                             #xformla = ~x,
                             control_group = "notyettreated",
                             clustervars = NULL,
                             bstrap = FALSE)
did_result <- did::aggte(did_result_gt, type = "calendar")
expect_equal(est_diff_ratio_agg(result, did_result), c(0,0), tolerance = tol,
             info = "time")
rm(result, did_result)

# bootstrap clustered --------------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "simple")
did_result_gt <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "ipw",cband = FALSE,
                             #xformla = ~x,
                             control_group = "notyettreated",
                             clustervars = NULL,
                             bstrap = FALSE)
did_result <- did::aggte(did_result_gt, type = "simple")
diffs <- c((did_result$overall.att-result[type == "post", att])/did_result$overall.att,
           (did_result$overall.se-result[type == "post", se])/did_result$overall.se)
expect_equal(diffs, c(0,0), tolerance = tol,
             info = "simple group")
rm(result, did_result)

# dynamic with balanced cohort -------------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "dynamic",
                  balanced_event_time = 4)
did_result_gt <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "ipw",cband = FALSE,
                             #xformla = ~x,
                             control_group = "notyettreated",
                             clustervars = NULL,
                             bstrap = FALSE)
did_result <- did::aggte(did_result_gt, type = "dynamic",
                         balance_e = 4)
expect_equal(est_diff_ratio_agg(result, did_result), c(0,0), tolerance = tol,
             info = "dynamic with balanced cohort")
rm(result, did_result)

# unbalanced ------------------------------

dt2 <- data.table::copy(dt)
keep <- sample(c(rep(TRUE, 15),FALSE), dt2[,.N], TRUE)
dt2 <- dt2[keep]

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                  allow_unbalance_panel = TRUE)
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",est_method = "ipw",cband = FALSE,
                          #xformla = ~x,
                          control_group = "notyettreated",
                          allow_unbalanced_panel = TRUE,
                          clustervars = NULL,
                          bstrap = FALSE)

expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "unbalanced method, balance panel, simple")
rm(result, did_result)

result <- fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                  allow_unbalance_panel = TRUE)
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt2,base_period = "universal",est_method = "ipw",cband = FALSE,
                          #xformla = ~x,
                          control_group = "notyettreated",
                          allow_unbalanced_panel = TRUE,
                          clustervars = NULL,
                          bstrap = FALSE)

expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "unbalanced method, unbalance panel, simple")
rm(result, did_result)

# unbalanced, ipw  ------------------------------------------

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                  control_type = "ipw",
                  covariatesvar = c("x", "x2"),
                  allow_unbalance_panel = TRUE)
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",cband = FALSE,
                          est_method = "ipw",xformla = ~x+x2,
                          control_group = "notyettreated",
                          allow_unbalanced_panel = TRUE,
                          clustervars = NULL,
                          bstrap = FALSE)

expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "unbalanced method, balance panel, ipw")
rm(result, did_result)

result <- fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  
                  result_type = "group_time",
                  control_type = "ipw",
                  covariatesvar = c("x", "x2"),
                  allow_unbalance_panel = TRUE)
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt2,
                          base_period = "universal",cband = FALSE,
                          est_method = "ipw",xformla = ~x+x2,
                          control_group = "notyettreated",
                          allow_unbalanced_panel = TRUE,
                          clustervars = NULL,
                          bstrap = FALSE)

expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "unbalanced method,unbalanced panel, data unbalanced, ipw")
rm(result, did_result)

# unbalanced, reg --------------------------------------------------------------------------

# reg and dr unbalanced will be used after the OR influence issues is resolved

result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                  control_type = "reg",
                  covariatesvar = c("x", "x2"),
                  allow_unbalance_panel = TRUE)
did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt,base_period = "universal",cband = FALSE,
                          est_method = "reg",xformla = ~x+x2,
                          control_group = "notyettreated",
                          allow_unbalanced_panel = TRUE,
                          clustervars = NULL,
                          bstrap = FALSE)
expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
             info = "unbalanced panel reg, but data balanced")
rm(result, did_result)

# estimate not the same, see coverage test
# result <- fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
#                   control_type = "reg",
#                   covariatesvar = c("x", "x2"),
#                   allow_unbalance_panel = TRUE)
# did_result <- did::att_gt(yname = "y",gname = "G",idname = "unit",tname = "time",data = dt2 ,base_period = "universal",cband = FALSE,
#                           est_method = "reg",xformla = ~x+x2,
#                           control_group = "notyettreated",
#                           allow_unbalanced_panel = TRUE,
#                           clustervars = NULL,
#                           bstrap = FALSE)
# 
# expect_equal(est_diff_ratio(result, did_result), c(0,0), tolerance = tol,
#              info = "unbalanced panel reg, but data unbalanced")
# rm(result, did_result)

#clean up environment -------------------------
rm(dt, simdt, tol, est_diff_ratio_agg)
detach("package:did", unload=TRUE)

# setup --------------------------------------------------------

tol <- 1e-2 #allow 1% different between estimates
simdt <- sim_did(1e+02, 10, cov = "cont", hetero = "all", balanced = TRUE, second_outcome = TRUE, seed = 1, 
                 stratify = FALSE, second_cov = TRUE, vary_cov = TRUE)
dt <- simdt$dt

# wrong dt ---------------

expect_warning(fastdid(as.data.frame(dt), timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time"),
             info = "data.frame")

dt2 <- data.table::copy(dt)
dt2 <- dt2[!is.infinite(G)]

expect_warning(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time"),
               info = "no never")

expect_error(fastdid(dt[time != 3], timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time"),
             info = "missing time")

expect_warning(fastdid(dt[time != 3 | unit != 20], timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y", result_type = "group_time"),
               info = "non-balanced panel, missing")

extra_row <-  dt[unit == 20 & time == 3]
expect_error(fastdid(rbind(dt,extra_row), timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time"),
             info = "non-balanced panel, extra")

dt2 <- data.table::copy(dt)
dt2[, x := 1]
expect_error(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit", outcomevar = "y",  result_type = "group_time",
                     covariatesvar = "x"),
             info = "covariates with no variation")

dt2 <- data.table::copy(dt)
dt2[G == Inf, x := x+10, by = "unit"]
expect_warning(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit", outcomevar = "y",  result_type = "group_time",
                     covariatesvar = "x", control_type = "ipw", control_option = "never"),
             info = "covariates with no overlap")

# warning for problematic dt ----------

dt2 <- data.table::copy(dt)
dt2[unit == 1 & time < 5, x := 3]
expect_warning(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit", outcomevar = "y",  result_type = "group_time",
                       covariatesvar = "x"),
               info = "time varying covariates is warned")

dt2 <- data.table::copy(dt)
dt2[unit == 1 & time == 4, time := NA]
dt2[time == 3 & unit > 30, y := NA]
expect_warning(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit", outcomevar = "y",  result_type = "group_time"),
               info = "missing values")


dt2 <- data.table::copy(dt)
dt2 <- dt2[!is.infinite(G)]
expect_warning(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit", outcomevar = "y",  result_type = "group_time",
                       control_option = "both"),
               info = "no never but both")

dt2 <- data.table::copy(dt)
dt2 <- dt2[!is.infinite(G)]
expect_error(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit", outcomevar = "y",  result_type = "group_time",
                       control_option = "never"),
               info = "no never but never")

# already_treated
dt_at <- data.table::copy(dt)
dt_at <- dt_at[time > min(G)]
expect_warning(fastdid(dt_at, timevar = "time", cohortvar = "G", unitvar = "unit", outcomevar = "y",  result_type = "group_time"),
               info = "already treated")

dt2 <- data.table::copy(dt)
dt2[, x := as.factor(round(x))]
expect_error(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit", outcomevar = "y",  result_type = "group_time", covariatesvar = "x"),
             info = "only numeric covariate")

# wrong arguments -------------------------------------------------

expect_error(fastdid::fastdid(dt, timevar = "time", cohortvar = "g", unitvar = "unit", outcomevar = "zz",  result_type = "group_time"),
             info = "wrong col name")

expect_error(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                     boot = FALSE, clustervar = "x"),
             info = "clustered but no boot")

expect_error(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                     boot = FALSE, clustervar = "x"),
             info = "clustered but no boot")

expect_error(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                     varycovariatesvar = "x2", allow_unbalanced_panel = TRUE),
             info = "unbalanced but vary")

#setup

#takes a lot of time so only at home # takes too much time, don't run every time
if(FALSE){
  
  #gotta go fast 
  setDTthreads(0)
  options(mc.cores = getDTthreads())
  
  
  cov_error_margin <- 0.01
  iter <- 200
  
  #doubledid boot
  covers <- c()
  pb <- progress::progress_bar$new(total = iter)
  for(i in 1:iter){
    simdt_c <- sim_did(1e+04, 5, hetero = "all", balanced = TRUE, second_outcome = TRUE, second_cohort = TRUE)
    dt_c <- simdt_c$dt
    result <- fastdid(dt_c, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      cohortvar2 = "G2", event_specific = TRUE, alpha = 0.05, boot = TRUE, cband = FALSE, parallel = TRUE)
    cov <- merge(simdt_c$att[event == 1], result, by.x = c("G", "time"), by.y = c("cohort", "time"))
    cov[, cover := as.numeric(attgt < att_ciub & attgt > att_cilb)]
    covers <- c(covers, cov[, cover])
    pb$tick()
  }
  mc <- mean(covers)
  # the standard error is sqrt(0.95*0.05/3200), so may wrongfully reject about 1% of time
  expect_true(mc > 0.95-cov_error_margin & mc < 0.95+cov_error_margin, info = "double did, bootstrap coverage")
  
  rm(mc, covers, simdt_c, dt_c, cov)
  
  #double did, analytical 
  pb <- progress::progress_bar$new(total = iter)
  covers <- c()
  for(i in 1:iter){
    simdt_c <- sim_did(1e+04, 5, hetero = "all", balanced = TRUE, second_outcome = TRUE, second_cohort = TRUE)
    dt_c <- simdt_c$dt
    result <- fastdid(dt_c, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      cohortvar2 = "G2", event_specific = TRUE, alpha = 0.05, boot = FALSE, cband = FALSE, parallel = TRUE)
    cov <- merge(simdt_c$att[event == 1], result, by.x = c("G", "time"), by.y = c("cohort", "time"))
    cov[, cover := as.numeric(attgt < att_ciub & attgt > att_cilb)]
    covers <- c(covers, cov[, cover])
    pb$tick()
  }
  mc <- mean(covers)
  # the standard error is sqrt(0.95*0.05/3200), so may wrongfully reject about 1% of time
  expect_true(mc > 0.95-cov_error_margin & mc < 0.95+cov_error_margin, info = "double did, analytical coverage")
  
  #unbalanced panel OR
  pb <- progress::progress_bar$new(total = iter)
  covers <- c()
  for(i in 1:iter){
    simdt_c <- sim_did(1e+03, 10, hetero = "all", balanced = TRUE, second_outcome = TRUE, cov = "cont")
    dt <- simdt_c$dt
    dt2 <- data.table::copy(dt)
    keep <- sample(c(rep(TRUE, 15),FALSE), dt2[,.N], TRUE)
    dt2 <- dt2[keep]
    result <- fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      allow_unbalance_panel = TRUE, covariatesvar = "x", control_type = "reg", parallel = TRUE)
    cov <- merge(simdt_c$att, result, by.x = c("G", "time"), by.y = c("cohort", "time"))
    cov[, cover := as.numeric(attgt < att_ciub & attgt > att_cilb)]
    covers <- c(covers, cov[, cover])
    pb$tick()
  }
  mc <- mean(covers)
  # the standard error is sqrt(0.95*0.05/3200), so may wrongfully reject about 1% of time
  expect_true(mc > 0.95-cov_error_margin & mc < 0.95+cov_error_margin, info = "unbalanced panel, regression")
}

# setup --------------------------------------------------------

tol <- 1e-2 #allow 1% different between estimates
simdt <- sim_did(1e+02, 10, cov = "cont", hetero = "all", balanced = TRUE, second_outcome = TRUE, seed = 1, 
                 stratify = FALSE, second_cov = TRUE, vary_cov = TRUE)
dt <- simdt$dt

# basics ---------------------------------------------

# fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
#         control_type = "ipw",
#         covariatesvar = c("x", "x2"))

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time"),
              info = "simple call")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      control_type = "ipw",
                      covariatesvar = c("x", "x2")),
              info = "covariates ipw")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      control_type = "reg",
                      covariatesvar = c("x", "x2")),
              info = "covariates reg")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      control_type = "dr",
                      covariatesvar = c("x", "x2")),
              info = "covariates dr")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      control_type = "dr",
                      covariatesvar = c("x", "x2"), varycovariatesvar = "xvar"),
              info = "with varying covariates dr")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      control_type = "dr",
                      varycovariatesvar = "xvar"),
              info = "varying covariates only dr")

expect_silent(fastdid(dt[G != 3], timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time"),
              info = "missing cohort")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time", alpha = 0.01),
              info = "alternative alpha")

#get full result
full_res <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = c("y", "y2"),  result_type = "group_time", full = TRUE)
expect_equal(names(full_res), c("call", "estimate", "gt_estimate", "agg_inf_func", "agg_weight_matrix"),
             info = "full result")

units <- dt[, unique(unit)]
weights <- data.table::data.table(unit = units, w = rnorm(length(units), 1, 1))
dt2 <- dt |> merge(weights, by = "unit")
expect_silent(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      weightvar = "w"),
              info = "weighted")

# bootstrap part ------------------------

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      boot = TRUE),
              info = "bootstrap")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      boot = TRUE, cband = TRUE),
              info = "uniform confidence interval")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time",
                      boot = TRUE, clustervar = "x"),
              info = "bootstrap clustered")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = c("y", "y2"),  result_type = "group_time",
                      boot = TRUE),
              info = "multiple outcome")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = c("y", "y2"),  result_type = "group_time",
                      boot = TRUE, covariatesvar = "x"),
              info = "multiple outcome with covariates")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time", allow_unbalance_panel = TRUE),
              info = "balance panel false but dt is balance")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time", allow_unbalance_panel = TRUE,
                      anticipation = 2),
              info = "anticipation")

expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time", allow_unbalance_panel = TRUE,
                      base_period = "varying"),
              info = "baseperiod vary")

# dt that needs adjustment ---------------------------

base_result <- fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time")

expect_equal(fastdid(dt[nrow(dt):1], timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time"), base_result,
              info = "reversed")

dt2 <- data.table::copy(dt)
dt2 <- dt2[G < 4]
expect_silent(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time", control_option = "notyet"),
              info = "limited treated group")


dt2 <- data.table::copy(dt)
dt2[, time := time*2 + 3]
dt2[, G := G*2 + 3]
base_result2 <- data.table::copy(base_result)
base_result2[, cohort := cohort*2 + 3]
base_result2[, time := time*2 + 3]

expect_equal(fastdid(dt2, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time"), 
             base_result2,
             info = "time offset")

# unbalanced panel ----------------------------------------------------

dt2 <- data.table::copy(dt)
keep <- sample(c(rep(TRUE, 19),FALSE), dt2[,.N], TRUE)
dt2 <- dt2[keep]


expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time", 
                      allow_unbalance_panel = TRUE),
              info = "balance panel false but dt is balance")

# internal behavor -------------------------

dt2 <- data.table::copy(dt)
data.table::setnames(dt2, c("time", "G", "unit"), c("t", "g", "u"))
expect_silent(fastdid(dt2, timevar = "t", cohortvar = "g", unitvar = "u",outcomevar = "y",  result_type = "group_time", alpha = 0.01),
              info = "other column names")

#make sure dt is not copied if copy == FALSE
if(at_home()){
  dtc <- data.table::copy(dt)
  address <- tracemem(dtc) |> stringr::str_remove_all(">|<")
  out <- capture.output(fastdid(dtc, timevar = "time", cohortvar = "G", unitvar = "unit", outcomevar = "y",  result_type = "group_time", copy = FALSE))
  #if a copy happen there will be a message at the start, so out[1] won't be the header. 
  expect_true(!stringr::str_detect(stringr::str_flatten_comma(out), address),
              info = "no unintentional copy")
}

if(.Platform$OS.type == "unix" & at_home() & requireNamespace("parallel")){
  expect_silent(fastdid(dt, timevar = "time", cohortvar = "G", unitvar = "unit",outcomevar = "y",  result_type = "group_time", parallel = TRUE),
                info = "parallel")
}

---
title: "Miscellaneous Topics"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{misc}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Performance

`fastdid` is magnitudes faster than [did](https://github.com/bcallaway11/did), and 15x faster than the fastest alternative [DiDforBigData](https://github.com/setzler/DiDforBigData) (dfbd for short) for large dataset. fastdid also uses less memory. Here is a comparison of run time for fastdid, did, and dfbd using a panel of 10 periods and varying samples sizes.

<img src="https://i.imgur.com/s5v32Rw.png" width="700px"/>

Unfortunately, the Author's computer fails to run **did** at 1 million units. For a rough idea, **DiDforBigData** is about 100x faster than **did** in Bradley Setzler's [benchmark](https://setzler.github.io/DiDforBigData/articles/Background.html). Other staggered DiD implementations are even slower than **did**. 

For memory:

<img src="https://i.imgur.com/7emkgOz.png" width="700px"/>

For the benchmark, a baseline group-time ATT is estimated with no covariates control, no bootstrap, and no explicit parallelization. Computing time is measured by `microbenchmark` and peak RAM by `peakRAM`.

# Validitiy 

Before each release, we conduct tests to ensure the validity of estimates from `fastdid`.

## Basics: comparison with `did`

For features included in CS, `fastdid` maintains a maximum of 1% difference from results from the `did` package. This margin of error is mostly for bootstrapped results due to its inherent randomess. For point estimates, the difference is smaller than 1e-12, and is most likely the result of [floating-point error](https://en.wikipedia.org/wiki/Floating-point_error_mitigation). The relevant test files are [compare_est.R](https://github.com/TsaiLintung/fastdid/blob/main/inst/tinytest/test_2_compare_est.R). 

## Extensions: coverage test

For features not included in CS, `fastdid` maintains that the 95% confidence intervals have a coverage rate between 94% and 96%. 

The coverage rate is calculated by running 200 iterations. In each iteration, we test whether the confidence interval estimated covers the group-truth values. We then average the rate across iterations. Due to the randomness of coverage, the realized coverage fall outside of the thresholds in about 1% of the time. The relevant test file is [coverage.R](https://github.com/TsaiLintung/fastdid/blob/main/inst/tinytest/test_99_coverage.R). 

## Experimental Features: not tested

As an attempt to balance the validity and flexibility of `fastdid`, "experimental features" is introduced in version 0.9.4. These features will be less tested and documented, and it is generally advised to not use them unless the user know what they and the package are doing. These experimental features can be accessed via the `exper` argument. For example, to use the `filtervar` feature, call `fastdid(..., exper = list(filtervar = "FF"))`. 

The current list of experimental features are

- `max_control_cohort_diff`: limit the max cohort difference between treated and control group
- `filtervar`, `filtervar_post`: limit the units being used as treated and control group with a potentially-time-varying variable in base (post) period
- `only_balance_2by2`: only require observations to have non-NA values within each 2 by 2 DiD, instead of throughout all time periods. Can be an alternative way of dealing with unbalanced panel by filling the missing periods with NAs. Not recommended as CS only have `allow_unbalance_panel`, which uses a repeated cross-section 2 by 2 DiD estimator.
- `custom_scheme`: aggregate to user-defined parameters


# Comparison with `did`

As the name suggests, **fastdid**'s goal is to be fast **did**. Besides performance, here are some comparisons between the two packages.

## Estimator

**fastdid**'s estimators is identical to **did**'s. As the performance gains mostly come from efficient data manipulation, the key estimation implementations are analogous. For example, 2x2 DiD (`estimate_did.R` and `DRDID::std_ipw_did_panel`), influence function from weights (`aggregate_gt.R/get_weight_influence`, `compute.aggte.R/wif`), and multiplier bootstrap (`get_se.R` and `mboot.R`).

## Interface

**fastdid** should feel similar to `att_gt`. But there are a few differences:

Control group option: 

```{r table1, echo=FALSE, message=FALSE, warnings=FALSE, results='asis'}
tabl <- "
| fastdid | did | control group used |
|-|-|-|
| both | notyettreated | never-treated + not-yet-but-eventually-treated |
| never| nevertreated  | never-treated |
| notyet | | not-yet-but-eventually-treated |
"
cat(tabl) # output the table in a format good for HTML/PDF/docx conversion
```

Aggregated parameters: `fastdid` aggregates in the same function.

```{r table2, echo=FALSE, message=FALSE, warnings=FALSE, results='asis'}
tabl <- "
| fastdid | did |
|-|-|
| group_time | no aggregation |
|dynamic|dynamic|
|time|calendar|
|group|group|
|simple|simple|
"
cat(tabl) # output the table in a format good for HTML/PDF/docx conversion
```

## Other

1. **fastdid** only offers inverse probability weights estimators for controlling for covariates when allowing for unbalanced panels.
2. **fastdid** use universal base periods as default. 

---
title: "Introduction to Double DiD"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{double}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

Here we show how to deal with confounding events, see [Tsai (2024)](https://arxiv.org/abs/2409.05184) for the full treatment. We first simulate some data with confounding events. 

```{r setup}
library(fastdid)
library(ggplot2)
library(data.table)
simdt <- sim_did(1e+04, 5, cov = "cont", hetero = "all", balanced = TRUE, seed = 1, 
                 second_cohort = TRUE, second_het = "no") #comfounding event
dt <- simdt$dt #dataset

#ground truth att
att <- simdt$att |> merge(dt[,.(w = .N),by = "G"], by = "G")
att[, event_time := time-G]
att <- att[event == 1,.(att = weighted.mean(attgt, w)), by = "event_time"]
```

Using the default estimator, the estimates (black line) is biased from the ground truth (red line).

```{r, naive}
naive_result <-fastdid(data = dt, 
                 timevar = "time", cohortvar = "G", unitvar = "unit", 
                 outcomevar = "y", result_type = "dynamic")
plot_did_dynamics(naive_result) + 
  geom_line(aes(y = att, x = event_time), 
            data = att, color = "red") + theme_bw()
```
Diagnostics can be obtained by using `time >= G2` as outcome. As we set the effect of the confounding event at 10 constantly, we can see that the bias of the default estimator is roughly 10 times the diagnostics.

```{r, diag}
dt[, D2 := time >= G2]
diag <- fastdid(data = dt, 
                 timevar = "time", cohortvar = "G", unitvar = "unit",
                 outcomevar = "D2", result_type = "dynamic")
plot_did_dynamics(diag) + theme_bw()
```

Using the double did estimator with `cohortvar2`, the estimator recovers the ground truth.

```{r, double}
double_result <-fastdid(data = dt, 
                 timevar = "time", cohortvar = "G", unitvar = "unit",
                 outcomevar = "y", result_type = "dynamic",
                 cohortvar2 = "G2", event_specific = TRUE)
plot_did_dynamics(double_result) + 
  geom_line(aes(y = att, x = event_time), 
            data = att, color = "red") + theme_bw()
```

Double DiD also allow for two additional aggregation scheme: group-group-time ("group_group_time") and dynamic-staggered ("dynamic_stagger", event time by event stagger, G1-G2).

```{r, agg}
double_result_ds <-fastdid(data = dt, 
                 timevar = "time", cohortvar = "G", unitvar = "unit",
                 outcomevar = "y", result_type = "dynamic_stagger",
                 cohortvar2 = "G2", event_specific = TRUE)

double_result_ggt <-fastdid(data = dt, 
                 timevar = "time", cohortvar = "G", unitvar = "unit",
                 outcomevar = "y", result_type = "group_group_time",
                 cohortvar2 = "G2", event_specific = TRUE)

```
